unit uTest;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, uComport;

type
  TForm1 = class(TForm)
    lCst: TLabel;
    GroupBox1: TGroupBox;
    chTxd: TCheckBox;
    chRTS: TCheckBox;
    chDTR: TCheckBox;
    grCom1: TGroupBox;
    openCom1: TButton;
    closeCOM1: TButton;
    GroupBox2: TGroupBox;
    chCTS: TCheckBox;
    chDCD: TCheckBox;
    chDSR: TCheckBox;
    chRI: TCheckBox;
    bStatus: TButton;
    Steuerleitungstimer: TTimer;
    eSendByte: TEdit;
    bByteSenden: TButton;
    Timer1: TTimer;
    bRotate: TButton;
    RotateTimer: TTimer;
    procedure openCom1Click(Sender: TObject);
    procedure closeCOM1Click(Sender: TObject);
    procedure chTxdClick(Sender: TObject);
    procedure timeTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chRTSClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chDTRClick(Sender: TObject);
    procedure bStatusClick(Sender: TObject);
    procedure SteuerleitungstimerTimer(Sender: TObject);
    procedure bByteSendenClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RotateTimerTimer(Sender: TObject);
    procedure bRotateClick(Sender: TObject);
  private
    { Private-Deklarationen }
        TH   : Boolean;
        CP   : TComPort;
        i    : integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.openCom1Click(Sender: TObject);
begin

if CP.OpenCom('COM1:9600,N,8,1') = 1 then
 begin
  lCst.Caption := 'COM1 offen!';
  chDTR.Enabled := True;
  chRTS.Enabled := True;
  chTXD.Enabled := True;
  bStatus.Enabled := True;
  openCom1.Enabled := False;
  closeCom1.Enabled := True;
 end
else
 begin
  lCst.Caption := 'Fehler';
  chTxd.Enabled := False;
  chRTS.Enabled := False;
  chDTR.Enabled := False;
  bStatus.Enabled := False;
 end;
end;

procedure TForm1.closeCOM1Click(Sender: TObject);
begin
 CP.CloseCOM;
 chDTR.Enabled := False;
 chRTS.Enabled := False;
 chTXD.Enabled := False;
 bStatus.Enabled := False;
 lCst.Caption := 'COM1 geschlossen!';
 openCom1.Enabled := True;
 closeCom1.Enabled := False;
end;

procedure TForm1.chTxdClick(Sender: TObject);
begin
 CP.TXD(StrToInt(BoolToStr(chTxd.Checked,false)));
end;

procedure TForm1.timeTimer(Sender: TObject);
begin
 if TH then
  begin
  CP.TXD(1);
  CP.RTS(0);
  end
 else
  begin
  CP.TXD(0);
  CP.RTS(1);
  end;

 TH := not TH;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 TH := False;
 CP := TComport.Create(0);
 i := 0;
end;

procedure TForm1.chRTSClick(Sender: TObject);
begin
 CP.RTS(StrToInt(BoolToStr(chRts.Checked,false)));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CP.Free;
end;

procedure TForm1.chDTRClick(Sender: TObject);
begin
 CP.DTR(StrToInt(BoolToStr(chDTR.Checked,false)));
end;

procedure TForm1.bStatusClick(Sender: TObject);
begin
 ShowMessage(CP.GetStatusReport);
end;

procedure TForm1.SteuerleitungstimerTimer(Sender: TObject);
begin

 with chCTS do
  begin
   if Boolean(CP.CTS) then
    begin
     Checked := True;
     Color := clGreen;
    end
   else
    begin
     Checked := False;
     Color := clRed;
    end;
  end;
//----------------------------------------------------------
 with chDSR do
  begin
   if Boolean(CP.DSR) then
    begin
     Checked := True;
     Color := clGreen;
    end
   else
    begin
     Checked := False;
     Color := clRed;
    end;
 end;
//-----------------------------------------------------------
 with chRI do
  begin
   if Boolean(CP.RI) then
    begin
     Checked := True;
     Color := clGreen;
    end
   else
    begin
     Checked := False;
     Color := clRed;
    end;
 end;
//-----------------------------------------------------------
 with chDCD do
  begin
   if Boolean(CP.DCD) then
    begin
     Checked := True;
     Color := clGreen;
    end
   else
    begin
     Checked := False;
     Color := clRed;
    end;
 end;
//-----------------------------------------------------------
end;

procedure TForm1.bByteSendenClick(Sender: TObject);
begin
 Timer1.Enabled := not Timer1.Enabled; 
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 try
  if eSendByte.Text <> '' then
  CP.SENDBYTE(StrToInt(eSendByte.Text));
 except
  on EConvertError do
   begin
    Timer1.Enabled := False;
    ShowMessage ('Ungltige Eingabe gefunden! Sendetimer wird abgeschaltet!');
   end;
 end;
end;

procedure TForm1.RotateTimerTimer(Sender: TObject);
begin
 eSendByte.Text := IntToStr(i);
 inc (i);
 if i >= 255 then
  i := 0;
end;

procedure TForm1.bRotateClick(Sender: TObject);
begin
 RotateTimer.Enabled := not RotateTimer.Enabled;
end;

end.
